/*****************************************************


  ==============================  

  -   AVR ATmega ATtiny 
 PIC   - http://proavr.narod.ru  

  -   -   AVR  PIC - avr123.nm.ru    pid.by.ru

    AVR.   

"   " -    !!!         - 
   .   http://proavr.narod.ru/05.htm  

==============================

ATmega8  ATmega48   48   DIP28        - 
  1  10  80 ,        
.            
 USB AVR910 USBASP PicKit2  - http://mkpochtoi.narod.ru

ATmega16   80   DIP40 

  USB AVR910 USBASP PicKit2  .


          "" 
       -     
         .    
   -  , . 
        .      

http://mkpochtoi.narod.ru

   .

==============================

     
       
CVAVR CodeVisinAVR - 

         .   http://proavr.narod.ru   

    http://proavr.narod.ru/06.htm 

CVAVR  -      . 


 -   translate.ru     

; ************************************************************

      VMLAB   4.3 Mb  
(   http://proavr.narod.ru )  :

http://proavr.narod.ru/z2.htm
http://proavr.narod.ru/z3.htm
http://proavr.narod.ru/z9.htm

        VMLAB

; ************************************************************

  "-"    
  -   :  http://proavr.narod.ru/z4.htm

     
///////////////////////////////////////////////////////////////

       - PROTEUS  !!! 

             
 
  http://proteus123.narod.ru

==============================

     -    - www.AVR123.nm.ru

 187   +  CD c     - -  .
http://torrents.ru/forum/viewtopic.php?t=1652142

==============================

AVR Studio 4.16  build 628. : 127 MB     :
     http://www.efo.ru/ftp/pub/atmel/_AVR_MCUs_8bit/AvrStudio/AVR%20Studio%204.16%20628/AvrStudio416Setup.exe

===============================


AVR Studio 4.17 (build 666) Software (updated 2009-07)

http://www.efo.ru/ftp/pub/atmel/_AVR_MCUs_8bit/AvrStudio/AVR%20Studio%204.17%20666/AvrStudio417Setup.exe

http://www.atmel.com/dyn/general/tech_doc.asp?doc_id=12246

  AVR - Tiny4, Tiny5, Tiny9, Tiny87, Tiny861A, Tiny2313A, Tiny4313, Mega16HVB, Mega16M1, Mega64M1, Mega64C1, Mega8U2, Mega16U2, Mega32U2, XMmega192D3, AT90SCR100, Mega128RFA1  .
  

AVR Studio 4.17 includes new device support and numerous overall enhancements;
Full AVR ONE! 8-bit support - both programming and debugging, AVR Battery Studio version 1.02, JTAGICE mkII command line SW with support for ELF production file format, and STK500 command line SW with support for ELF production file format. 

===============================

AVR Studio 4.18 (build 684) (116 MB, updated 11/09)

http://www.atmel.com/dyn/products/tools_card.asp?tool_id=2725



AVR Studio 4.18 Part Pack 1 -  

http://www.atmel.no/beta_ware/avrstudio418/pp1/AVR_Studio_4.18_PP1.exe

AVR Studio 4.18 PP1 adds support for 5 new devices: ATmega328, ATmega164A, ATmega324A, ATmega644A, ATmega1284 


===============================

  ATMEL - http://www.atmel.com/dyn/products/tools.asp?family_id=607

  ATMEL   - http://www.atmel.no/beta_ware/




Project : 
Version : 
Date    : 06.01.2010
Author  : NeVaDa
Company : 
Comments: 


Chip type               : ATmega32
Program type            : Application
AVR Core Clock frequency: 11,059200 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 512
*****************************************************/

#include <mega32.h>
#include <delay.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#define dig_0 0b00111111
#define dig_1 0b00000110
#define dig_2 0b01011011
#define dig_3 0b01001111
#define dig_4 0b01100110
#define dig_5 0b01101101
#define dig_6 0b01111101
#define dig_7 0b00000111
#define dig_8 0b01111111
#define dig_9 0b01101111

// Declare your global variables here
unsigned int adc_data;
unsigned char ADCstr[4];
// ADC interrupt service routine
void sendLCD(unsigned int pos, unsigned char digitChar)
{
unsigned int digit;
 switch (digitChar) {
    case '0': digit = dig_0; break;     
    case '1': digit = dig_1; break;
    case '2': digit = dig_2; break;
    case '3': digit = dig_3; break;
    case '4': digit = dig_4; break;
    case '5': digit = dig_5; break;
    case '6': digit = dig_6; break;
    case '7': digit = dig_7; break;
    case '8': digit = dig_8; break;
    case '9': digit = dig_9; break;
    };
    switch (pos) {
    case 2: PORTD = digit; break; 
    case 1: PORTC = digit; break;
    case 0: PORTB = digit; break;
    }; 
}

interrupt [ADC_INT] void adc_isr(void)
{
float adc_value;
unsigned int i;
unsigned int l = strlen(ADCstr);
// Read the AD conversion result
adc_data=ADCW;

adc_value = floor(adc_data*255/500);

itoa(adc_value, ADCstr);

    for (i = 0; i < l; i++) {
        switch (i) {
        case 2: sendLCD(2, ADCstr[i]); break; 
        case 1: sendLCD(1, ADCstr[i]); break;
        case 0: sendLCD(0, ADCstr[i]); break;
        }; 

    }


ADCSRA |= (1<<6); //  

}

void init_avr(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC Clock frequency: 86,400 kHz
// ADC Voltage Reference: Int., cap. on AREF
ADMUX=0b11010000;
ADCSRA=0x8F;

// 2 Wire Bus initialization
// Generate Acknowledge Pulse: Off
// 2 Wire Bus Slave Address: 0h
// General Call Recognition: Off
// Bit Rate: 394,971 kHz
TWSR=0x00;
TWBR=0x06;
TWAR=0x00;
TWCR=0x04;

// Global enable interrupts
#asm("sei")
}

void main(void)
{

init_avr();

ADCSRA |= (1<<6); //  

while (1)
      {
      // Place your code here

      };
}
